VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ForceFeedEffects8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Effect"
Attribute VB_Ext_KEY = "Member0" ,"Effect"
'##CD Collection of Effect objects.
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private mvarParent As GameController8
Private EffectEnum As DirectInputEnumEffects

Public Property Set Parent(ByVal vData As GameController8)
    Set mvarParent = vData
End Property

Public Property Get Parent() As GameController8
'##BD GameController8 object one level above this object.
    Set Parent = mvarParent
End Property

Public Sub Clear()
'##BD Removes all the Effects objects from the collection.
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub

Friend Function Add(Key As String, DynamicParams As Long, Guid As String, EffectName As String, StaticParams As Long, _
                                        EffectType As Long, Optional sKey As String) As ForceFeedEffect8
    'create a new object
    Dim objNewMember As ForceFeedEffect8
    
    Set objNewMember = New ForceFeedEffect8

    'set the properties passed into the method
    With objNewMember
        .Key = Key
        Call .SetProperties(DynamicParams, Guid, EffectName, StaticParams, EffectType)
        Set .Parent = Me 'Set the parent
    End With
    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As ForceFeedEffect8
Attribute Item.VB_UserMemId = 0
'##BD Returns a specific member of a collection.
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
'##BD Removes all the ForceFeedEffect8 objects from the collection.
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
'##BD Removes a Effect object from the collection.
    Call mCol.Remove(vntIndexKey)
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Friend Sub SetEffectsEnumObject(oEffectEnum As DirectInputEnumEffects)
    Set EffectEnum = oEffectEnum
End Sub
Friend Function GetEffectsEnumObject() As DirectInputEnumEffects
    Set GetEffectsEnumObject = EffectEnum
End Function
Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    
End Sub

Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
    Set mvarParent = Nothing
End Sub
