VERSION 5.00
Begin VB.Form IntForm 
   BackColor       =   &H00000000&
   Caption         =   "TrueVision8 Engine - Sylvain Dupont / Christopher D.Parker"
   ClientHeight    =   8325
   ClientLeft      =   855
   ClientTop       =   510
   ClientWidth     =   10185
   LinkTopic       =   "Form1"
   ScaleHeight     =   555
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   679
   Begin VB.PictureBox Terrain 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   2370
      Left            =   2010
      ScaleHeight     =   158
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   195
      TabIndex        =   0
      Top             =   1590
      Visible         =   0   'False
      Width           =   2925
   End
End
Attribute VB_Name = "IntForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Implements DirectXEvent8

Public GameControllers As GameControllers8
Public Sub ForceCallBack()
    ' Get the list of current properties
    ' USB joysticks wont call this callback until you play with the joystick
    ' so we call the callback ourselves the first time
    Call DirectXEvent8_DXCallback(0)
End Sub


Private Sub DirectXEvent8_DXCallback(ByVal eventid As Long)
    Dim GameController As GameController8
    
    If eventid = 0 Then Exit Sub 'Exit for fakes
    
    'Check to see if the eventid if for the keyboard or mouse.
    If (eventid = lKeyEvent) Or (eventid = lMouseEvent) Then
        'Update mouse state
        Call DIMouseDevice.GetDeviceStateMouse(MouseState)
        Call LocalInput.FireEvents(1, CBool(MouseState.Buttons(0)), CBool(MouseState.Buttons(1)), CBool(MouseState.Buttons(2)), _
                                                            CBool(MouseState.Buttons(3)), MouseState.lX, MouseState.lY, MouseState.lZ)
        
        'Update keyboard state.
        
    End If
            
    'Cycle through each controller on the system to see if it's event id matches the eventid parameter. If so we fire the change event to the client.
    For Each GameController In GameControllers
        If eventid = GameController.GetEventID Then
            If GameController.InUse Then GameController.FireChangeEvent 'Fire the change event if we are using this controller.
        End If
    Next GameController 'Move to the next controller.
    
    Set GameController = Nothing
End Sub


